/*
 * Copy me if you can.
 * by 20h
 */

#include <u.h>
#include <libc.h>

char be[] =
	"01234567";

void
b8enc(int in, int out)
{
	char s[4], o[9];
	int l;

	memset(s, 0, 4);
	memset(o, 0, 9);

	while((l = readn(in, s, 3)) > 0) {
		o[0] = be[(s[0] & 0xE0) >> 5];
		o[1] = be[(s[0] & 0x1C) >> 2];
		o[2] = be[((s[0] & 0x03) << 1) | ((s[1] & 0x80) >> 7)];
		o[3] = be[(s[1] & 0x70) >> 4];
		o[4] = be[(s[1] & 0x0E) >> 1];
		o[5] = be[((s[1] & 0x01) << 2) | ((s[2] & 0xC0) >> 6)];
		o[6] = be[(s[2] & 0x38) >> 3];
		o[7] = be[s[2] & 0x07];

		switch(l) {
		case 1:
			o[3] = o[4] = o[5] = '=';
		case 2:
			o[6] = o[7] = '=';
		default:
			break;
		}
		write(out, o, 8);

		memset(s, 0, 4);
		memset(o, 0, 9);
	}
}

void
b8dec(int in, int out)
{
	char bd[256], s[9], o[4];
	int l;

	l = -1;
	memset(bd, 0x80, 256);
	while(++l < strlen(be))
		bd[be[l]] = l;
	bd['='] = 0;

	memset(s, 0, 9);
	memset(o, 0, 4);

	while(readn(in, s, 8) >= 8) {
		o[0] = (bd[s[0] & 0xFF] << 5) | (bd[s[1] & 0xFF] << 2) | ((bd[s[2] & 0xFF] & 0x06) >> 1);
		o[1] = ((bd[s[2] & 0xFF] & 0x01) << 7) | (bd[s[3] & 0xFF] << 4) | (bd[s[4] & 0xFF] << 1) | ((bd[s[5] & 0xFF] & 0x04) >> 2);
		o[2] = ((bd[s[5] & 0xFF] & 0x03) << 6) | (bd[s[6] & 0xFF] << 3) | bd[s[7] & 0xFF];

		l = 3;
		if(s[7] == '=' && s[6] == '=' && s[5] == '=')
			l = 2;
		if(s[4] == '=' && s[3] == '=' && s[2] == '=')
			l = 1;
		write(out, o, l);

		memset(s, 0, 9);
		memset(o, 0, 4);
	}
}

void
usage(void)
{
	print("usage: [-d]\n");
	exits(0);
}

void
main(int argc, char *argv[])
{
	int dec;

	dec = 0;

	ARGBEGIN {
		case 'd':
			dec = 1;
			break;
		default:
			usage();
	} ARGEND;

	if(dec)
		b8dec(0, 1);
	else
		b8enc(0, 1);

	exits(0);
}
